/*
 * Copyright 2015 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include <iostream>
#include <string>
#include <vector>
#include <sstream>
#include <cameo/cameo.h>

using namespace std;
using namespace cameo;


int main(int argc, char *argv[]) {

	/**
	 * This goal of the test was to test the linger value. In fact, it does not seem important for us.
	 *
	application::This::init(argc, argv);

	// New block to ensure cameo objects are terminated before the application.
	{

		// Sleep time between send and receive.
		int sleepTime = 0;
		if (argc > 2) {
			sleepTime = stoi(argv[1]);

			cout << "sleep time is " << sleepTime << endl;
		}

		unique_ptr<application::Instance> responderApplication = application::This::connectToStarter();

		// Create a requester.
		unique_ptr<application::Requester> requester = application::Requester::create(*responderApplication, "responder");

		cout << "created requester " << *requester << endl;

		application::This::setRunning();

		try {
			// send a simple message.
			requester->send("request");

			// sleep.
			this_thread::sleep_for(chrono::milliseconds(sleepTime));

			// response.
			string response;
			requester->receive(response);
			cout << "response is " << response << endl;

		} catch (...) {
			cout << "error" << endl;
		}

		cout << "finished the application" << endl;
	}
*/

	return 0;
}

