/*
 * Copyright 2015 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include <cameo/cameo.h>
#include <cameo/JSON.h>

using namespace std;
using namespace cameo;

int main(int argc, char *argv[]) {

	application::This::init(argc, argv);

	{
		string key = "fr.ill.ics.cameo.test.testkey";

		json::StringObject valueObject;
		valueObject.pushKey("x");
		valueObject.pushInt(12);

		application::This::getCom().storeKeyValue(key, valueObject.toString());

		try {
			string valueString = application::This::getCom().getKeyValue(key);

			json::Object value;
			json::parse(value, valueString);

			cout << "x = " << value["x"].GetInt() << endl;

			application::This::getCom().removeKey(key);
		}
		catch (const UndefinedKeyException& e) {
		}

		try {
			application::This::getCom().getKeyValue(key);
		}
		catch (const UndefinedKeyException& e) {
			cout << "cannot remove key : " << e.what() << endl;
		}

		cout << "finished the application" << endl;
	}

	return 0;
}

